/*
 * WATCHDOG.h
 *
 *  Created on: 16 de abr. de 2016
 *      Author: lanselot
 */

#ifndef WATCHDOG_H_
#define WATCHDOG_H_

#include <stdint.h>

/**
 * Enables the watchdog functionality for resetting the microcontroller on
 * timeout
 *
 * @param countDownMs The amount of time in ms the watchdog can wait to be fed
 */
void WatchDog_enable(uint16_t countDownMs);

/**
 * Feeds the watchdog, and so resets the timeout counter.
 */
void WatchDog_feed();

#endif /* WATCHDOG_H_ */
