#include "Timer.h"
#include "LPC17xx.h"
#include "bit.h"

static uint8_t initialized = 0;

volatile uint32_t *Timer_usTime = &(LPC_TIM0->TC);

void Timer_Setup()
{
	if (!initialized) {
		initialized = 1;
		Bit_on(LPC_SC->PCONP, 1 << 1);
		LPC_TIM0->PR = 24;
		LPC_TIM0->TCR = 3;
		LPC_TIM0->TCR = 1;
	}
}

void Timer_usDelay(uint32_t us)
{
	uint32_t startTs = LPC_TIM0->TC;

	while(Timer_usElapsed(startTs) < us);
}

void Timer_msDelay(uint32_t ms)
{
	Timer_usDelay(ms * 1000);
}

uint32_t Timer_usElapsed(uint32_t previousTs)
{
	uint32_t currentTs = LPC_TIM0->TC;

	if (currentTs < previousTs) {
		return 0xFFFFFFFF - previousTs + currentTs;
	} else {
		return currentTs - previousTs;
	}
}
