#include "debug.h"
#include "FreeRTOS.h"
#include "task.h"
#include <stdint.h>

static xTaskHandle taskHandles[DEBUG_NUM_TASKS];

void Debug_StackMonitor()
{
	uint8_t i;
	for(;;) {
		for(i=0; i < DEBUG_NUM_TASKS; ++i) {
			if (taskHandles[i]) {
				printf("Task %d stack left %d\n", i, uxTaskGetStackHighWaterMark(taskHandles[i]));
			}
		}
		vTaskDelay(DEBUG_STACK_ITERATION_DELAY);
	}
}

xTaskHandle* Debug_getTaskHandler(uint8_t index)
{
	return &taskHandles[index];
}
