/**
 * EcuFeedback Module.
 * Provides a task for polling the ECU status and printing the results to
 * the LCD.
 */
#ifndef ECUFEEDBACK_H_
#define ECUFEEDBACK_H_

#include "portmacro.h"
#include <stdint.h>

#define ECUFEEDBACK_POLLING_INTERVAL 5000
#define ECUFEEDBACK_MAX_RPM_SAMPLES 5000 / ECUFEEDBACK_POLLING_INTERVAL

#define	ECUFEEDBACK_SPORT_MODE_AVG 6000
#define ECUFEEDBACK_SPORT_MODE_SHIFT 9000

#define	ECUFEEDBACK_STANDARD_MODE_AVG 4200
#define ECUFEEDBACK_STANDARD_MODE_SHIFT 6000

#define	ECUFEEDBACK_ECO_MODE_AVG 4000
#define ECUFEEDBACK_ECO_MODE_SHIFT 4500

#define ECUFEEDBACK_BLINK_PERIOD 100
#define ECUFEEDBACK_BLINK_TIMES 15



/**
 * Initializes the EcuFeedback module
 */
void EcuFeedback_Setup();

/**
 * A task that polls the ECU and prints the results to the LCD
 */
void EcuFeedback_Task();

#endif /* ECUFEEDBACK_H_ */
